"""
This file contains and defines tests for use in rtems_bench.

Any new tests should be added to module variable tests to be seen by the bench.
"""

import lib


class Test:
    def __init__(self, name, func, has_image):
        self.name = name
        self.func = func
        self.has_image = has_image

    def run(self):
        self.func(self) #

def nop(self):
    print(self.name)
    for l in (2, 4, 6, 8):
        lib.call_latester(" -d can0 -d can1 -d can2 -c 10000 {0} -l {1} -n len{1}".format(lib.get_latester_arg(l), l))
        lib.create_plot_script()


def nop_time(self):
    print(self.name)
    lib.symlink_results(lib.original_name_from_histogram_name(self.name))
    lib.create_plot_script()

def nop_highprio(self):
    nop(self)

def nop_highprio_time(self):
    nop_time(self)


tests = (Test("nop", nop, True),
         Test("nop-time", nop_time, False),
         Test("nop-highprio", nop_highprio, True),
         Test("nop-highprio-time", nop_highprio_time, False))